libosmogb 1.13.1.1-afb4 Osmocom Gb library

Data Fields
bssgp_flow_control Struct Reference

BSSGP flow control (SGSN side) According to Section 8.2. More...

`#include <gprs_bssgp.h>`

## Data Fields
uint32_t | bucket_size_max
| maximum size of the bucket (octets) More...
uint32_t | bucket_leak_rate
| leak rate of the bucket (octets/sec) More...
uint32_t | bucket_counter
| number of tokens in the bucket More...
struct timeval | time_last_pdu
| timestamp of last PDU sent More...
uint32_t | max_queue_depth
| how many packets to queue (mgs) More...
uint32_t | queue_depth
| current length of queue (msgs) More...
struct llist_head | queue
| linked list of msgb's More...
struct osmo_timer_list | timer
| timer-based dequeueing More...
int(* | out_cb )(struct bssgp_flow_control *fc, struct msgb *msg, uint32_t llc_pdu_len, void *priv)
| callback to be called at output of flow control More...

## Detailed Description

BSSGP flow control (SGSN side) According to Section 8.2.

## Field Documentation

## ◆ bucket_counter

uint32_t bssgp_flow_control::bucket_counter

number of tokens in the bucket

Referenced by bssgp_fc_needs_queueing(), and dump_bvc().

## ◆ bucket_leak_rate

uint32_t bssgp_flow_control::bucket_leak_rate

leak rate of the bucket (octets/sec)

Referenced by bssgp_fc_init(), bssgp_fc_needs_queueing(), bssgp_rx_fc_bvc(), dump_bvc(), and fc_queue_timer_cfg().

## ◆ bucket_size_max

uint32_t bssgp_flow_control::bucket_size_max

maximum size of the bucket (octets)

Referenced by bssgp_fc_in(), bssgp_fc_init(), bssgp_rx_fc_bvc(), and dump_bvc().

## ◆ max_queue_depth

uint32_t bssgp_flow_control::max_queue_depth

how many packets to queue (mgs)

Referenced by bssgp_fc_init(), dump_bvc(), and fc_enqueue().

## ◆ out_cb

int(* bssgp_flow_control::out_cb) (struct bssgp_flow_control *fc, struct msgb *msg, uint32_t llc_pdu_len, void *priv)

callback to be called at output of flow control

Referenced by bssgp_fc_in(), bssgp_fc_init(), and fc_timer_cb().

## ◆ queue

struct llist_head bssgp_flow_control::queue

linked list of msgb's

Referenced by bssgp_fc_flush_queue(), bssgp_fc_init(), fc_enqueue(), fc_queue_timer_cfg(), and fc_timer_cb().

## ◆ queue_depth

uint32_t bssgp_flow_control::queue_depth

current length of queue (msgs)

Referenced by dump_bvc(), fc_enqueue(), and fc_timer_cb().

## ◆ time_last_pdu

struct timeval bssgp_flow_control::time_last_pdu

timestamp of last PDU sent

Referenced by bssgp_fc_in(), bssgp_fc_init(), bssgp_fc_needs_queueing(), and fc_timer_cb().

## ◆ timer

struct osmo_timer_list bssgp_flow_control::timer

timer-based dequeueing

Referenced by bssgp_bvc_ctx_free(), and fc_queue_timer_cfg().

The documentation for this struct was generated from the following file:

- include/osmocom/gprs/gprs_bssgp.h